diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index 3397ae039..ed57f4a23 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -1121,27 +1121,28 @@ public final class Blocks {
     public static final @NotNull Block<?> GLOWSTONE = register("glowstone", "minecraft:block/glowstone", 820, (b) -> new BlockLogicGlowStone(b, Materials.STONE))
         .withSound(BlockSounds.GLASS).withHardness(0.3F).withLightEmission(1.0F).withOverrideColor(MaterialColor.paintedYellow)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-    public static final Block<?> RUBYGLASS = register("rubyglass", "minecraft:block/rubyglass", 821, (b) -> new BlockLogicRubyglass(b))
-        .withSound(BlockSounds.GLASS).withHardness(0.3F)
+
+    public static final Block<?> RUBYGLASS_COLUMN = register("rubyglass.column", "minecraft:block/rubyglass_column", 821, (b) -> new BlockLogicRubyglass(b))
+        .withSound(BlockSounds.GLASS).withHardness(3F).withLightEmission(0.8F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE)
         .withOverrideColor(MaterialColor.rubyglass);
-    public static final Block<?> RUBYGLASS_PURE = register("rubyglass.pure", "minecraft:block/rubyglass_pure", 822, (b) -> new BlockLogicTransparent(b, Materials.STONE))
-        .withSound(BlockSounds.GLASS).withHardness(0.3F)
+    public static final Block<?> BLOCK_RUBYGLASS = register("block.rubyglass", "minecraft:block/block_rubyglass", 822, (b) -> new BlockLogicTransparent(b, Materials.STONE))
+        .withSound(BlockSounds.GLASS).withHardness(3F).withLightEmission(0.8F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE)
         .withOverrideColor(MaterialColor.rubyglass);
-    public static final Block<?> RUBYGLASS_SPROUT = register("rubyglass.growth", "minecraft:block/rubyglass_growth", 823, (b) -> new BlockLogicRubyglassGrowth(b))
+    public static final Block<?> RUBYGLASS_SPROUT = register("rubyglass.sprout", "minecraft:block/rubyglass_sprout", 823, (b) -> new BlockLogicRubyglassSprout(b))
         .withSound(BlockSounds.GLASS).withDisabledNeighborNotifyOnMetadataChange().withLightEmission(0.8F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE)
         .withOverrideColor(MaterialColor.rubyglass);
     public static final Block<?> RUBYGLASS_CIRCUIT = register("rubyglass.circuit", "minecraft:block/rubyglass_circuit", 824, (b) -> new BlockLogic(b, Materials.STONE))
-        .withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange().withHardness(0.5F)
+        .withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange().withHardness(1F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN, BlockTags.CAVES_CUT_THROUGH, BlockTags.NETHER_MOBS_SPAWN)
         .withOverrideColor(MaterialColor.rubyglass);
 
-    public static final Block<?> RUBYGLASS_BUD = register("rubyglass.bud", "minecraft:block/rubyglass_bud", 825, (b) -> new BlockLogicRubyglassCrop(b))
-            .withSound(BlockSounds.GLASS).withDisabledNeighborNotifyOnMetadataChange().withLightEmission(0.8F)
-            .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU)
-        .withOverrideColor(MaterialColor.rubyglass);
+    public static final Block<?> RUBYGLASS_NODE = register("rubyglass.node", "minecraft:block/rubyglass_node", 826, (b) -> new BlockLogicOreRubyglass(b))
+            .withSound(BlockSounds.GLASS).withHardness(3F).withLightEmission(0.5F)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE)
+            .withOverrideColor(MaterialColor.rubyglass);
 
     public static final @NotNull Block<BlockLogicPortal> PORTAL_NETHER = register("portal.nether", "minecraft:block/portal_nether", 830, (BlockLogicSupplier<BlockLogicPortal>) b -> new BlockLogicPortal(b, Dimension.NETHER, Blocks.OBSIDIAN, Blocks.FIRE))
         .withSound(BlockSounds.GLASS).withHardness(-1F).withLightEmission(0.75F).withOverrideColor(MaterialColor.paintedPurple).withDisabledStats()
diff --git a/game/core/src/main/java/net/minecraft/core/block/FluidWater.java b/game/core/src/main/java/net/minecraft/core/block/FluidWater.java
index e9484a1fa..f7ea21c99 100644
--- a/game/core/src/main/java/net/minecraft/core/block/FluidWater.java
+++ b/game/core/src/main/java/net/minecraft/core/block/FluidWater.java
@@ -23,15 +23,21 @@ public class FluidWater
     @Override
     public void animationTick(final @NotNull BlockLogicFluid logicFluid, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand) {
         final int data = world.getBlockData(tilePos) & 0x0F;
-        TilePos up = tilePos.up(new TilePos());
-        final boolean isTop = world.getBlockMaterial(up) == Materials.AIR && !world.isBlockOpaqueCube(up);
+        TilePos queryPos = new TilePos();
+        final boolean isTop = world.getBlockMaterial(tilePos.up(queryPos)) == Materials.AIR && !world.isBlockOpaqueCube(tilePos.up(queryPos));
+        final boolean isBottom = world.isBlockOpaqueCube(tilePos.down(queryPos));
         if (data > 0 && data < 8) {
             if (rand.nextInt(64) == 0) {
                 world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float) tilePos.x() + 0.5F, (float) tilePos.y() + 0.5F, (float) tilePos.z() + 0.5F, "liquid.water", rand.nextFloat() * 0.25F + 0.75F, rand.nextFloat() * 1.0F + 0.5F);
             }
         }
-        if (world.getWorldType().hasTag(WorldTypeTags.NETHER) && isTop && data == 0 && rand.nextInt(4) == 0) {
-            world.spawnParticle("smoke", tilePos.x() + Math.random(), tilePos.y() + (14f / 16f), tilePos.z() + Math.random(), 0.0D, 0.0D, 0.0D, 1);
+        if (world.getWorldType().hasTag(WorldTypeTags.NETHER)) {
+//            if (isTop && data == 0 && rand.nextInt(4) == 0) {
+//                world.spawnParticle("smoke", tilePos.x() + Math.random(), tilePos.y() + (14f / 16f), tilePos.z() + Math.random(), 0.0D, 0.0D, 0.0D, 1);
+//            }
+            if ((isBottom || rand.nextInt(16) == 0) && data == 0 && rand.nextInt(2) == 0) {
+                world.spawnParticle("bubbleboiling", tilePos.x() + Math.random(), tilePos.y() + 0.05f, tilePos.z() + Math.random(), 0, 0, 0, 0);
+            }
         }
 
         if (rand.nextInt(4) == 0 && world.getBlockType(tilePos.down(new TilePos())).solid() && !world.getBlockType(tilePos.down(new TilePos()).down()).solid()) {
diff --git a/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRules.java b/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRules.java
index 5dda2658f..d6199334e 100644
--- a/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRules.java
+++ b/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRules.java
@@ -17,8 +17,8 @@ public abstract class GameRules
     public static GameRuleBoolean DO_FIRE_SPREAD = register(new GameRuleBoolean("doFireSpread", "gamerule.do_fire_spread", true));
     public static GameRuleBoolean INSTANT_HEALING = register(new GameRuleBoolean("instantHealing", "gamerule.instant_healing", false));
     public static GameRuleInteger RANDOM_TICK_SPEED = register(new GameRuleInteger("randomTickSpeed", "gamerule.random_tick_speed", 4));
-    public static GameRuleInteger ITEM_DESPAWN_DELAY = register(new GameRuleInteger("itemDespawnDelay", "gamerule.item_despawn_delay", 6000));
-    public static GameRuleInteger DROPPED_ITEM_DESPAWN_DELAY = register(new GameRuleInteger("droppedItemDespawnDelay", "gamerule.dropped_item_despawn_delay", 6000));
+    public static GameRuleInteger ITEM_DESPAWN_DELAY = register(new GameRuleInteger("itemDespawnDelay", "gamerule.item_despawn_delay", 12000));
+    public static GameRuleInteger DROPPED_ITEM_DESPAWN_DELAY = register(new GameRuleInteger("droppedItemDespawnDelay", "gamerule.dropped_item_despawn_delay", 12000));
 
     public static <T extends GameRule<?>> T register(T gameRule)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
index ead3acd26..b21344618 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
@@ -14,6 +14,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemDiscMusic;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
@@ -92,18 +93,24 @@ public class EntityItem extends Entity
         {
             this.pickupDelay--;
         }
+        boolean inLava = isInLava();
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
-        this.yd -= 0.04D;
-        if(isInLava())
-        {
-            this.yd = 0.2D;
-            this.xd = (this.random.nextFloat() - this.random.nextFloat()) * 0.2F;
-            this.zd = (this.random.nextFloat() - this.random.nextFloat()) * 0.2F;
-            this.world.playSoundAtEntity(null, this, "random.fizz", 0.4F, 2.0F + this.random.nextFloat() * 0.4F);
-        }
 
+        if (item.getItem().hasTag(ItemTags.IS_FIRE_PROOF)) {
+            this.yd += (this.wasInWater || inLava) ? 0.02D : -0.04D;
+        } else {
+            this.yd += this.wasInWater ? 0.02D : -0.04D;
+
+            if(isInLava())
+            {
+                this.yd = 0.2D;
+                this.xd = (this.random.nextFloat() - this.random.nextFloat()) * 0.2F;
+                this.zd = (this.random.nextFloat() - this.random.nextFloat()) * 0.2F;
+                this.world.playSoundAtEntity(null, this, "random.fizz", 0.4F, 2.0F + this.random.nextFloat() * 0.4F);
+            }
+        }
         checkAndPushInTile(this.x, (this.bb.minY + this.bb.maxY) / 2D, this.z);
         move(this.xd, this.yd, this.zd);
         
@@ -143,7 +150,7 @@ public class EntityItem extends Entity
             this.yd *= -0.5D;
         }
         this.age++;
-        if(this.age >= this.lifetime && this.lifetime >= 0) // Negative lifetime indicates items should last forever
+        if(this.age >= this.lifetime && this.lifetime >= 0 && !this.item.getItem().hasTag(ItemTags.IS_PERSISTENT)) // Negative lifetime indicates items should last forever
         {
             remove();
         }
@@ -158,12 +165,22 @@ public class EntityItem extends Entity
     @Override
 	protected void burn(int damage)
     {
-        hurt(null, damage, DamageType.FIRE);
+        if (!this.item.getItem().hasTag(ItemTags.IS_FIRE_PROOF)) {
+            hurt(null, damage, DamageType.FIRE);
+        }
     }
 
     @Override
     public boolean hurt(Entity entity, int i, DamageType type)
     {
+        if (this.item.getItem().hasTag(ItemTags.IS_INDESTRUCTIBLE)) {
+            return false;
+        }
+        else if (type == DamageType.FIRE && this.item.getItem().hasTag(ItemTags.IS_FIRE_PROOF)) {
+            return false;
+        } else if (type == DamageType.BLAST && this.item.getItem().hasTag(ItemTags.IS_BLAST_PROOF)) {
+            return false;
+        }
         markHurt();
         this.health -= i;
         if(this.health <= 0)
diff --git a/game/core/src/main/java/net/minecraft/core/item/Items.java b/game/core/src/main/java/net/minecraft/core/item/Items.java
index c01f9a317..cdb68cf16 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Items.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Items.java
@@ -205,8 +205,8 @@ public final class Items {
     public static Item SIGN_PAINTED;
     public static Item DOUGH;
     public static Item WAND_NBT;
-    public static Item RUBYGLASS_CRYSTAL_CRACKED;
-    public static Item RUBYGLASS_CRYSTAL_PURE;
+    public static Item RUBYGLASS_DUST;
+    public static Item RUBYGLASS_CRYSTAL;
 
 
     private static boolean hasInit = false;
@@ -252,7 +252,7 @@ public final class Items {
         TOOL_BOW = (new ItemBow("tool.bow", "minecraft:item/tool_bow", 16389));
         AMMO_ARROW = (new Item("ammo.arrow", "minecraft:item/ammo_arrow", 16390));
         COAL = (new ItemCoal("coal", "minecraft:item/coal", 16391));
-        DIAMOND = (new Item("diamond", "minecraft:item/diamond", 16392));
+        DIAMOND = (new Item("diamond", "minecraft:item/diamond", 16392)).withTags(ItemTags.IS_FIRE_PROOF);
         INGOT_IRON = (new Item("ingot.iron", "minecraft:item/ingot_iron", 16393));
         INGOT_GOLD = (new Item("ingot.gold", "minecraft:item/ingot_gold", 16394));
         TOOL_SWORD_IRON = (new ItemToolSword("tool.sword.iron", "minecraft:item/tool_sword_iron", 16395, ToolMaterial.iron)).withTags(ItemTags.PREVENT_CREATIVE_MINING);
@@ -264,10 +264,10 @@ public final class Items {
         TOOL_SHOVEL_STONE = (new ItemToolShovel("tool.shovel.stone", "minecraft:item/tool_shovel_stone", 16401, ToolMaterial.stone));
         TOOL_PICKAXE_STONE = (new ItemToolPickaxe("tool.pickaxe.stone", "minecraft:item/tool_pickaxe_stone", 16402, ToolMaterial.stone));
         TOOL_AXE_STONE = (new ItemToolAxe("tool.axe.stone", "minecraft:item/tool_axe_stone", 16403, ToolMaterial.stone));
-        TOOL_SWORD_DIAMOND = (new ItemToolSword("tool.sword.diamond", "minecraft:item/tool_sword_diamond", 16404, ToolMaterial.diamond)).withTags(ItemTags.PREVENT_CREATIVE_MINING);
-        TOOL_SHOVEL_DIAMOND = (new ItemToolShovel("tool.shovel.diamond", "minecraft:item/tool_shovel_diamond", 16405, ToolMaterial.diamond));
-        TOOL_PICKAXE_DIAMOND = (new ItemToolPickaxe("tool.pickaxe.diamond", "minecraft:item/tool_pickaxe_diamond", 16406, ToolMaterial.diamond));
-        TOOL_AXE_DIAMOND = (new ItemToolAxe("tool.axe.diamond", "minecraft:item/tool_axe_diamond", 16407, ToolMaterial.diamond));
+        TOOL_SWORD_DIAMOND = (new ItemToolSword("tool.sword.diamond", "minecraft:item/tool_sword_diamond", 16404, ToolMaterial.diamond)).withTags(ItemTags.PREVENT_CREATIVE_MINING, ItemTags.IS_FIRE_PROOF);
+        TOOL_SHOVEL_DIAMOND = (new ItemToolShovel("tool.shovel.diamond", "minecraft:item/tool_shovel_diamond", 16405, ToolMaterial.diamond)).withTags(ItemTags.IS_FIRE_PROOF);
+        TOOL_PICKAXE_DIAMOND = (new ItemToolPickaxe("tool.pickaxe.diamond", "minecraft:item/tool_pickaxe_diamond", 16406, ToolMaterial.diamond)).withTags(ItemTags.IS_FIRE_PROOF);
+        TOOL_AXE_DIAMOND = (new ItemToolAxe("tool.axe.diamond", "minecraft:item/tool_axe_diamond", 16407, ToolMaterial.diamond)).withTags(ItemTags.IS_FIRE_PROOF);
         STICK = (new Item("stick", "minecraft:item/stick", 16408));
         BOWL = (new Item("bowl", "minecraft:item/bowl", 16409));
         FOOD_STEW_MUSHROOM = (new ItemSoup("food.stew.mushroom", "minecraft:item/food_stew_mushroom", 16410, 10, 16));
@@ -281,7 +281,7 @@ public final class Items {
         TOOL_HOE_WOOD = (new ItemToolHoe("tool.hoe.wood", "minecraft:item/tool_hoe_wood", 16418, ToolMaterial.wood));
         TOOL_HOE_STONE = (new ItemToolHoe("tool.hoe.stone", "minecraft:item/tool_hoe_stone", 16419, ToolMaterial.stone));
         TOOL_HOE_IRON = (new ItemToolHoe("tool.hoe.iron", "minecraft:item/tool_hoe_iron", 16420, ToolMaterial.iron));
-        TOOL_HOE_DIAMOND = (new ItemToolHoe("tool.hoe.diamond", "minecraft:item/tool_hoe_diamond", 16421, ToolMaterial.diamond));
+        TOOL_HOE_DIAMOND = (new ItemToolHoe("tool.hoe.diamond", "minecraft:item/tool_hoe_diamond", 16421, ToolMaterial.diamond)).withTags(ItemTags.IS_FIRE_PROOF);
         TOOL_HOE_GOLD = (new ItemToolHoe("tool.hoe.gold", "minecraft:item/tool_hoe_gold", 16422, ToolMaterial.gold));
         SEEDS_WHEAT = (new ItemSeeds("seeds.wheat", "minecraft:item/seeds_wheat", 16423, Blocks.CROPS_WHEAT)).withTags(ItemTags.CHICKENS_FAVOURITE_ITEM);
         WHEAT = (new Item("wheat", "minecraft:item/wheat", 16424)).withTags(ItemTags.COWS_FAVOURITE_ITEM);
@@ -302,10 +302,10 @@ public final class Items {
         ARMOR_LEGGINGS_IRON = (new ItemArmor("armor.leggings.iron", "minecraft:item/armor_leggings_iron", 16436, ArmorMaterial.IRON, HumanArmorShape.LEGS));
         ARMOR_BOOTS_IRON = (new ItemArmor("armor.boots.iron", "minecraft:item/armor_boots_iron", 16437, ArmorMaterial.IRON, HumanArmorShape.BOOTS));
 
-        ARMOR_HELMET_DIAMOND = (new ItemArmor("armor.helmet.diamond", "minecraft:item/armor_helmet_diamond", 16438, ArmorMaterial.DIAMOND, HumanArmorShape.HEAD));
-        ARMOR_CHESTPLATE_DIAMOND = (new ItemArmor("armor.chestplate.diamond", "minecraft:item/armor_chestplate_diamond", 16439, ArmorMaterial.DIAMOND, HumanArmorShape.CHEST));
-        ARMOR_LEGGINGS_DIAMOND = (new ItemArmor("armor.leggings.diamond", "minecraft:item/armor_leggings_diamond", 16440, ArmorMaterial.DIAMOND, HumanArmorShape.LEGS));
-        ARMOR_BOOTS_DIAMOND = (new ItemArmor("armor.boots.diamond", "minecraft:item/armor_boots_diamond", 16441, ArmorMaterial.DIAMOND, HumanArmorShape.BOOTS));
+        ARMOR_HELMET_DIAMOND = (new ItemArmor("armor.helmet.diamond", "minecraft:item/armor_helmet_diamond", 16438, ArmorMaterial.DIAMOND, HumanArmorShape.HEAD)).withTags(ItemTags.IS_FIRE_PROOF);
+        ARMOR_CHESTPLATE_DIAMOND = (new ItemArmor("armor.chestplate.diamond", "minecraft:item/armor_chestplate_diamond", 16439, ArmorMaterial.DIAMOND, HumanArmorShape.CHEST)).withTags(ItemTags.IS_FIRE_PROOF);
+        ARMOR_LEGGINGS_DIAMOND = (new ItemArmor("armor.leggings.diamond", "minecraft:item/armor_leggings_diamond", 16440, ArmorMaterial.DIAMOND, HumanArmorShape.LEGS)).withTags(ItemTags.IS_FIRE_PROOF);
+        ARMOR_BOOTS_DIAMOND = (new ItemArmor("armor.boots.diamond", "minecraft:item/armor_boots_diamond", 16441, ArmorMaterial.DIAMOND, HumanArmorShape.BOOTS)).withTags(ItemTags.IS_FIRE_PROOF);
 
         ARMOR_HELMET_GOLD = (new ItemArmor("armor.helmet.gold", "minecraft:item/armor_helmet_gold", 16442, ArmorMaterial.GOLD, HumanArmorShape.HEAD));
         ARMOR_CHESTPLATE_GOLD = (new ItemArmor("armor.chestplate.gold", "minecraft:item/armor_chestplate_gold", 16443, ArmorMaterial.GOLD, HumanArmorShape.CHEST));
@@ -366,18 +366,18 @@ public final class Items {
         RECORD_WAIT = (new ItemDiscMusic("record.wait", "minecraft:item/record_wait", 18394, "record.wait", "C418"));
         RECORD_DOG = (new ItemDiscMusic("record.dog", "minecraft:item/record_dog", 18395, "record.dog", "C418"));
         NETHERCOAL = (new Item("nethercoal", "minecraft:item/nethercoal", 16488));
-        ARMOR_HELMET_STEEL = (new ItemArmor("armor.helmet.steel", "minecraft:item/armor_helmet_steel", 16489, ArmorMaterial.STEEL, HumanArmorShape.HEAD));
-        ARMOR_CHESTPLATE_STEEL = (new ItemArmor("armor.chestplate.steel", "minecraft:item/armor_chestplate_steel", 16490, ArmorMaterial.STEEL, HumanArmorShape.CHEST));
-        ARMOR_LEGGINGS_STEEL = (new ItemArmor("armor.leggings.steel", "minecraft:item/armor_leggings_steel", 16491, ArmorMaterial.STEEL, HumanArmorShape.LEGS));
-        ARMOR_BOOTS_STEEL = (new ItemArmor("armor.boots.steel", "minecraft:item/armor_boots_steel", 16492, ArmorMaterial.STEEL, HumanArmorShape.BOOTS));
+        ARMOR_HELMET_STEEL = (new ItemArmor("armor.helmet.steel", "minecraft:item/armor_helmet_steel", 16489, ArmorMaterial.STEEL, HumanArmorShape.HEAD)).withTags(ItemTags.IS_BLAST_PROOF);
+        ARMOR_CHESTPLATE_STEEL = (new ItemArmor("armor.chestplate.steel", "minecraft:item/armor_chestplate_steel", 16490, ArmorMaterial.STEEL, HumanArmorShape.CHEST)).withTags(ItemTags.IS_BLAST_PROOF);
+        ARMOR_LEGGINGS_STEEL = (new ItemArmor("armor.leggings.steel", "minecraft:item/armor_leggings_steel", 16491, ArmorMaterial.STEEL, HumanArmorShape.LEGS)).withTags(ItemTags.IS_BLAST_PROOF);
+        ARMOR_BOOTS_STEEL = (new ItemArmor("armor.boots.steel", "minecraft:item/armor_boots_steel", 16492, ArmorMaterial.STEEL, HumanArmorShape.BOOTS)).withTags(ItemTags.IS_BLAST_PROOF);
 
-        TOOL_SWORD_STEEL = (new ItemToolSword("tool.sword.steel", "minecraft:item/tool_sword_steel", 16493, ToolMaterial.steel)).withTags(ItemTags.PREVENT_CREATIVE_MINING);
-        TOOL_SHOVEL_STEEL = (new ItemToolShovel("tool.shovel.steel", "minecraft:item/tool_shovel_steel", 16494, ToolMaterial.steel));
-        TOOL_PICKAXE_STEEL = (new ItemToolPickaxe("tool.pickaxe.steel", "minecraft:item/tool_pickaxe_steel", 16495, ToolMaterial.steel));
-        TOOL_AXE_STEEL = (new ItemToolAxe("tool.axe.steel", "minecraft:item/tool_axe_steel", 16496, ToolMaterial.steel));
-        TOOL_HOE_STEEL = (new ItemToolHoe("tool.hoe.steel", "minecraft:item/tool_hoe_steel", 16497, ToolMaterial.steel));
+        TOOL_SWORD_STEEL = (new ItemToolSword("tool.sword.steel", "minecraft:item/tool_sword_steel", 16493, ToolMaterial.steel)).withTags(ItemTags.PREVENT_CREATIVE_MINING, ItemTags.IS_BLAST_PROOF);
+        TOOL_SHOVEL_STEEL = (new ItemToolShovel("tool.shovel.steel", "minecraft:item/tool_shovel_steel", 16494, ToolMaterial.steel)).withTags(ItemTags.IS_BLAST_PROOF);
+        TOOL_PICKAXE_STEEL = (new ItemToolPickaxe("tool.pickaxe.steel", "minecraft:item/tool_pickaxe_steel", 16495, ToolMaterial.steel)).withTags(ItemTags.IS_BLAST_PROOF);
+        TOOL_AXE_STEEL = (new ItemToolAxe("tool.axe.steel", "minecraft:item/tool_axe_steel", 16496, ToolMaterial.steel)).withTags(ItemTags.IS_BLAST_PROOF);
+        TOOL_HOE_STEEL = (new ItemToolHoe("tool.hoe.steel", "minecraft:item/tool_hoe_steel", 16497, ToolMaterial.steel)).withTags(ItemTags.IS_BLAST_PROOF);
 
-        INGOT_STEEL = (new Item("ingot.steel", "minecraft:item/ingot_steel", 16498));
+        INGOT_STEEL = (new Item("ingot.steel", "minecraft:item/ingot_steel", 16498)).withTags(ItemTags.IS_BLAST_PROOF);
         INGOT_STEEL_CRUDE = (new Item("ingot.steel.crude", "minecraft:item/ingot_steel_crude", 16499));
         AMMO_FIREBALL = (new Item("ammo.fireball", "minecraft:item/ammo_fireball", 16500)).withTags(ItemTags.NOT_IN_CREATIVE_MENU);
         ARMOR_QUIVER_GOLD = (new ItemQuiverEndless("armor.quiver.gold", "minecraft:item/armor_quiver_gold", 16501));
@@ -407,8 +407,8 @@ public final class Items {
         BASKET = new ItemPlaceable("basket", "minecraft:item/basket", 16525, Blocks.BASKET);
         FLAG = new ItemFlag("flag", "minecraft:item/flag", 16526);
         ARMOR_BOOTS_ICESKATES = new ItemIceSkates("armor.boots.iceskates", "minecraft:item/armor_boots_iceskates", 16527);
-        TOOL_SHEARS_STEEL = (ItemToolShears)(new ItemToolShears("tool.shears.steel", "minecraft:item/tool_shears_steel", 16528, ToolMaterial.steel)).setMaxDamage(ToolMaterial.steel.getDurability());
-        TOOL_FIRESTRIKER_STEEL = (new ItemFireStriker("tool.firestriker.steel", "minecraft:item/tool_firestriker_steel", 16529)).setMaxDamage(ToolMaterial.steel.getDurability());
+        TOOL_SHEARS_STEEL = (ItemToolShears)(new ItemToolShears("tool.shears.steel", "minecraft:item/tool_shears_steel", 16528, ToolMaterial.steel)).setMaxDamage(ToolMaterial.steel.getDurability()).withTags(ItemTags.IS_BLAST_PROOF);
+        TOOL_FIRESTRIKER_STEEL = (new ItemFireStriker("tool.firestriker.steel", "minecraft:item/tool_firestriker_steel", 16529)).setMaxDamage(ToolMaterial.steel.getDurability()).withTags(ItemTags.IS_BLAST_PROOF);
         SEEDS_PUMPKIN = (new ItemSeeds("seeds.pumpkin", "minecraft:item/seeds_pumpkin", 16530, Blocks.CROPS_PUMPKIN)).withTags(ItemTags.CHICKENS_FAVOURITE_ITEM);
         SEAT = new ItemPlaceable("seat", "minecraft:item/seat", 16531, Blocks.SEAT).setMaxStackSize(64);
         DOOR_OAK_PAINTED = (new ItemDoorPainted("door.oak.painted", "minecraft:item/door_oak_painted", 16532, Blocks.DOOR_PLANKS_PAINTED_BOTTOM, Blocks.DOOR_PLANKS_PAINTED_TOP));
@@ -416,7 +416,7 @@ public final class Items {
         ROPE = new ItemRope("rope", "minecraft:item/rope", 16534, Blocks.ROPE);
         FOOD_PUMPKIN_PIE = (new ItemPlaceable("food.pumpkin_pie", "minecraft:item/food_pumpkin_pie", 16535, Blocks.PUMPKIN_PIE)).setMaxStackSize(1);
         WAND_MONSTER_SPAWNER = (new ItemWandSpawner("wand.monster", "minecraft:item/wand_monster", 16536)).setMaxStackSize(1);
-        DOOR_STEEL = (new ItemDoor("door.steel", "minecraft:item/door_steel", 16537, Blocks.DOOR_STEEL_BOTTOM, Blocks.DOOR_STEEL_TOP));
+        DOOR_STEEL = (new ItemDoor("door.steel", "minecraft:item/door_steel", 16537, Blocks.DOOR_STEEL_BOTTOM, Blocks.DOOR_STEEL_TOP)).withTags(ItemTags.IS_BLAST_PROOF);
         PAINTBRUSH = new ItemPaintBrush("paintbrush", "minecraft:item/paintbrush", 16538);
         JAR_BUTTERFLY_BLUE = new ItemPlaceable("jar.butterfly.blue", "minecraft:item/jar_butterfly_blue", 16539, Blocks.JAR_BUTTERFLY_BLUE);
         JAR_BUTTERFLY_ORANGE = new ItemPlaceable("jar.butterfly.orange", "minecraft:item/jar_butterfly_orange", 16540, Blocks.JAR_BUTTERFLY_ORANGE);
@@ -433,7 +433,7 @@ public final class Items {
         FOOD_VENISON_COOKED = (new ItemFood("food.venison.cooked", "minecraft:item/food_venison_cooked", 16551, 12, 8, true, 4));
         DOUGH = (new Item("dough", "minecraft:item/dough", 16552));
         WAND_NBT = new ItemWandNBT("wand.nbt", "minecraft:item/wand_nbt", 16553);
-        RUBYGLASS_CRYSTAL_CRACKED = (new ItemCrystalBud("rubyglass.crystal.cracked", "minecraft:item/rubyglass_crystal_cracked", 16554));
-        RUBYGLASS_CRYSTAL_PURE = (new ItemCrystalBud("rubyglass.crystal.pure", "minecraft:item/rubyglass_crystal_pure", 16555));
+        RUBYGLASS_DUST = (new Item("rubyglass.crystal.cracked", "minecraft:item/rubyglass_crystal_cracked", 16554));
+        RUBYGLASS_CRYSTAL = (new Item("rubyglass.crystal.pure", "minecraft:item/rubyglass_crystal_pure", 16555));
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/tag/ItemTags.java b/game/core/src/main/java/net/minecraft/core/item/tag/ItemTags.java
index e4edf7f3d..82f2cbd54 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tag/ItemTags.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tag/ItemTags.java
@@ -38,6 +38,26 @@ public abstract class ItemTags
      */
     public static final @NotNull Tag<Item> COWS_FAVOURITE_ITEM = Tag.of("cows_favourite_item");
 
+    /**
+     * Items with this tag will not burn in fire or lava
+     */
+    public static final @NotNull Tag<Item> IS_FIRE_PROOF = Tag.of("is_fire_proof");
+
+    /**
+     * Items with this tag will not be destroyed by explosions
+     */
+    public static final @NotNull Tag<Item> IS_BLAST_PROOF = Tag.of("is_blast_proof");
+
+    /**
+     * Item entities with this tag will be able to be killed
+     */
+    public static final @NotNull Tag<Item> IS_INDESTRUCTIBLE = Tag.of("is_indestructible");
+
+    /**
+     * Items with this tag won't despawn
+     */
+    public static final @NotNull Tag<Item> IS_PERSISTENT = Tag.of("is_persistent");
+
     public static final @NotNull List<@NotNull Tag<@NotNull Item>> TAG_LIST;
 
     static
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeParticleId.java b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeParticleId.java
index 4291996c8..fe3cbdcf2 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeParticleId.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeParticleId.java
@@ -29,6 +29,7 @@ public class ArgumentTypeParticleId implements ArgumentType<String> {
         particleIds.add("reddust");
         particleIds.add("soulflame");
         particleIds.add("bubble");
+        particleIds.add("bubbleboiling");
         particleIds.add("explode");
         particleIds.add("slimechunk");
         particleIds.add("block");
@@ -48,6 +49,7 @@ public class ArgumentTypeParticleId implements ArgumentType<String> {
         particleIds.add("fireflyRed");
         particleIds.add("splash");
         particleIds.add("ashmote");
+        particleIds.add("ventsmoke");
     }
 
     private static final List<String> EXAMPLES = Arrays.asList("fireflyGreen", "explode", "soulflame");
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
index 2c2707ee7..36153bc53 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.chunk.perlin.nether;
 
 import net.minecraft.core.block.BlockLogicOreNetherCoal;
+import net.minecraft.core.block.BlockLogicOreRubyglass;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
@@ -71,6 +72,13 @@ public class ChunkDecoratorNether
                         .withPlacementMethod(new PlacementMethod.TriesPerChunk(4))
         );
 
+        this.register("minecraft:decoration/nether/default/rubyglass_node",
+                new ChunkDecorationBuilder(new WorldFeatureOre(BlockLogicOreRubyglass.variantMap, 5))
+                        .withBiomeMask(new Biome[]{ Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_PLAINS})
+                        .withPositionSelector(PositionSelectors.HeightRangeUniform)
+                        .withPlacementMethod(new PlacementMethod.TriesPerChunk(10))
+        );
+
         this.register("minecraft:decoration/nether/default/rubyglass_sprout_patch",
                 new ChunkDecorationBuilder(new WorldFeatureRubyglassSproutPatch())
                         .withBiomeMask(new Biome[]{ Biomes.NETHER_CRYSTAL_FOREST, Biomes.NETHER_CRYSTAL_PLAINS})
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRubyglassCrystal.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRubyglassCrystal.java
index 59bb9911e..50415b5d2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRubyglassCrystal.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureRubyglassCrystal.java
@@ -161,16 +161,18 @@ public class WorldFeatureRubyglassCrystal implements WorldFeatureInterface {
                     return null;
                 }
 
+                boolean ore = random.nextInt(50) == 0;
+
                 final float distancePctg = faceDistances[0] / length;
                 if (distancePctg < BASE_PCTG) {
                     final float innerDistancePctg = distancePctg / BASE_PCTG;
                     if (innerDistancePctg < random.nextFloat()) {
                         return Blocks.COBBLE_NETHERRACK_CRYSTALLINE;
                     } else {
-                        return Blocks.RUBYGLASS;
+                        return ore ? Blocks.RUBYGLASS_NODE : Blocks.RUBYGLASS_COLUMN;
                     }
                 } else {
-                    return Blocks.RUBYGLASS;
+                    return ore ? Blocks.RUBYGLASS_NODE : Blocks.RUBYGLASS_COLUMN;
                 }
             }
         );
@@ -184,7 +186,7 @@ public class WorldFeatureRubyglassCrystal implements WorldFeatureInterface {
         for (ti.y = tilePos.y(); ti.y < tilePos.y() + base; ti.y++) {
             for (ti.x = tilePos.x() - base; ti.x < tilePos.x() + base; ti.x++) {
                 for (ti.z = tilePos.z() - base; ti.z < tilePos.z() + base; ti.z++) {
-                    if (world.getBlockType(ti) == Blocks.RUBYGLASS)
+                    if (world.getBlockType(ti) == Blocks.RUBYGLASS_COLUMN)
                         return false;
                 }
             }
